<?php
/*
Plugin Name: WP-Cron-Mail Extended
Plugin URI: http://www.cneophytou.com/2006/03/14/wp-cron-mail-plugin/
Description: Does blog-by-email stuff, in conjunction with WP-Cron. Modified by <a href="http://www.cneophytou.com/">Constantinos Neopyhtou</a>. <a href="http://www.skippy.net/blog/plugins/">Original source</a> of plugin.
Version: 1.5
Author: Scott Merrill
Author URI: http://www.skippy.net/
 
expanded from Scott Merrill's wp-cron-mail, which was
based on core wp-mail.php
released under the terms of the GNU GPL
*/

function wp_cron_mail($output = false) {
// change this to 1 if you want to always get a notification
// even if nothing happened.
$always_notify = cron_mail_get_option("always_notify");

global $wpdb;

$logfile = '';
require_once(ABSPATH.WPINC.'/class-pop3.php');
if (!function_exists('wp_insert_category')) {
	require_once(ABSPATH . '/wp-admin/admin-db.php');
}

// I don't think we want to display errors, so let's use whatever
// the webserver uses by default.  Remove the slashes below to override.
// error_reporting(2037);

$time_difference = get_settings('gmt_offset') * 3600;

$phone_delim = '::';

$pop3 = new POP3();

if (!$pop3->connect(get_settings('mailserver_url'), get_settings('mailserver_port'))) :
	wp_cron_send_mail('error', "Ooops $pop3->ERROR \r\n", $output);
	return;
endif;

$count = $pop3->login(get_settings('mailserver_login'), get_settings('mailserver_pass'));
if (0 == $count) {
	if ($always_notify || $output) {
		wp_cron_send_mail('status', __("There doesn't seem to be any new mail.", 'cron_mail'), $output);
	}
	return;
}

for ($i=1; $i <= $count; $i++) :

	$message = $pop3->get($i);

	$content = '';
	$content_type = '';
	$boundary = '';
	$bodysignal = 0;
	$categorysignal = 0;
	$dmonths = array('Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun',
					 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec');
	foreach ($message as $line) :
		if (strlen($line) < 3) $bodysignal = 1;

		if ($bodysignal && $categorysignal) {
			$content .= $line;
		} elseif ($bodysignal) {
			$categorymatches = array();
			$overwritecategory = preg_match('/\{\*([\sa-zA-Z0-9\,]+)\*\}/i', $line, $categorymatches);
			if ($overwritecategory) {
				$requested_categories = explode(',', $categorymatches[1]);
				$requested_categories = array_map('trim', $requested_categories);
				$post_categories = array();
				$default_category_name = get_cat_name(1);
				foreach($requested_categories as $key => $value) {
					$category_id = intval($value);
					if (!$category_id) {
						$category_id = get_cat_ID($value);
						if ($category_id == 1 && $value != $default_category_name) {
							$category_id = wp_insert_category(array("cat_name" => $value));
						}
					}
					$post_categories[$key] = $category_id;
				}
			}
			if (strlen(trim($line)) || ($overwritecategory)) {
				$categorysignal = 1;
				// Don't skip the line if it wasn't categories...
				if (!$overwritecategory) {
					$content .= $line;
				}
			}
		} else {
			if (preg_match('/Content-Type: /i', $line)) {
				$content_type = trim($line);
				$content_type = substr($content_type, 14, strlen($content_type)-14);
				$content_type = explode(';', $content_type);
				$content_type = $content_type[0];
			}
			if (($content_type == 'multipart/alternative') && (preg_match('/boundary="/', $line)) && ($boundary == '')) {
				$boundary = trim($line);
				$boundary = explode('"', $boundary);
				$boundary = $boundary[1];
			}
			if (preg_match('/Subject: /i', $line)) {
				$subject = trim($line);
				$subject = substr($subject, 9, strlen($subject)-9);
				if (!preg_match('#\=\?(.+)\?Q\?(.+)\?\=#i', $subject)) {
				  $subject = wp_iso_descrambler($subject);
				}
				// Captures any text in the subject before $phone_delim as the subject
				$subject = explode($phone_delim, $subject);
				$subject = $subject[0];
			}

			// Set the author using the email address (To or Reply-To, the last used)
			// otherwise use the site admin
			// SDM: added slash to beginning to 2nd preg_match
			if (preg_match('/From: /', $line) | preg_match('/Reply-To: /', $line))  {
				$author=trim($line);
				if ( ereg("([a-zA-Z0-9\_\-\.]+@[\a-zA-z0-9\_\-\.]+)", $author , $regs) ) {
					$logfile .= "Author = {$regs[1]} \r\n";
					$author_email = $regs[1];
					$result = $wpdb->get_row("SELECT ID FROM $wpdb->users WHERE user_email='$regs[1]' ORDER BY ID DESC LIMIT 1");
					if (!$result) {
						// email address is not on file, check options
						$valid_addresses = trim(cron_mail_get_option('valid_address'));
						if ($valid_addresses == "*") {
							// Ignore sender, go ahead and post as admin.
							$post_author = 1;
						} else {
							$post_author = 0;
							$valid_addresses = explode(',', $valid_addresses);
							// Check accepted addresses.
							foreach($valid_addresses as $key => $value) {
								if (strtolower(trim($value)) == strtolower($regs[1])) {
									$post_author = 1;
								}
							}
						}
					} else {
						if (cron_mail_get_option('min_user_level') <= $result->ID) {
							$post_author = $result->ID;
						} else {
							$post_author = 0;
						}
					}
				} else {
					$post_author = 1;
				}
			}

			if (preg_match('/Date: /i', $line)) { // of the form '20 Mar 2002 20:32:37'
				$ddate = trim($line);
				$ddate = str_replace('Date: ', '', $ddate);
				if (strpos($ddate, ',')) {
					$ddate = trim(substr($ddate, strpos($ddate, ',')+1, strlen($ddate)));
				}
				$date_arr = explode(' ', $ddate);
				$date_time = explode(':', $date_arr[3]);
				
				$ddate_H = $date_time[0];
				$ddate_i = $date_time[1];
				$ddate_s = $date_time[2];
				
				$ddate_m = $date_arr[1];
				$ddate_d = $date_arr[0];
				$ddate_Y = $date_arr[2];
				for ($j=0; $j<12; $j++) {
					if ($ddate_m == $dmonths[$j]) {
						$ddate_m = $j+1;
					}
				}

				$time_zn = intval($date_arr[4]) * 36;
				$ddate_U = gmmktime($ddate_H, $ddate_i, $ddate_s, $ddate_m, $ddate_d, $ddate_Y);
				$ddate_U = $ddate_U - $time_zn;
				$post_date = gmdate('Y-m-d H:i:s', $ddate_U + $time_difference);
				$post_date_gmt = gmdate('Y-m-d H:i:s', $ddate_U);
			}
		}
	endforeach;

	if (!$post_author) {
		// originating email address is not valid. act accordingly.
		$logfile .= "This email was NOT from an authorised e-mail address.\r\n";
		$user_message = "Your email was not processed.";
		mail($author_email, 'wp-mail failed attempt', $user_message);
		// delete message
		if(!$pop3->delete($i)) {
			$logfile .= 'Oops '.$pop3->ERROR."\r\n";
			$pop3->reset();
			wp_cron_send_mail('error', $logfile, $output);
			return;
		} else {
			$logfile .= "Mission complete, message $i deleted.\r\n";
		}
		continue;
	}
	
	$subject = addslashes(trim(str_replace(get_settings('subjectprefix'), '', $subject)));

	if ($content_type == 'multipart/alternative') {
		$content = explode('--'.$boundary, $content);
		$content = $content[2];
		$content = explode('Content-Transfer-Encoding: quoted-printable', $content);
		$content = strip_tags($content[1], '<img><p><br><i><b><u><em><strong><strike><font><span><div>');
	}
	$content = trim($content);
	// Captures any text in the body after $phone_delim as the body
	$content = explode($phone_delim, $content);
	$content[1] ? $content = $content[1] : $content = $content[0];

	$logfile .= "Content-type: $content_type, boundary: $boundary\r\n";
	$logfile .= "Raw content:\r\n$content\r\n";

	$content = trim(addslashes($content));

	$post_content = apply_filters('phone_content', $content);

	$post_title = xmlrpc_getposttitle($content);

	if ($post_title == '') $post_title = $subject;

	if (empty($post_categories)) $post_categories[] = get_settings('default_email_category');

	$post_category = $post_categories;

	// or maybe we should leave the choice to email drafts? propose a way
	$post_status = cron_mail_get_option('publish_post');

	$post_data = compact('post_content','post_title','post_date','post_date_gmt','post_author','post_category', 'post_status');

	$post_ID = wp_insert_post($post_data);

	if (!$post_ID) {
		// we couldn't post, for whatever reason. better move forward to the next email
		continue;
	}

	do_action('publish_phone', $post_ID);

	if (!$post_categories) $post_categories[] = 1;
	if (!$requested_categories) $requested_categories = $post_categories;
	
	$logfile .=  "Author: $post_author\r\n";
	$logfile .=  "Posted title: $post_title\r\n";
	$logfile .=  "Posted categories: ".implode(', ', $requested_categories)."\r\n";
	$logfile .=  "Posted content:\r\n$content\r\n";

/*
	foreach ($post_categories as $post_category) :
		$post_category = intval($post_category);

		// Double check it's not there already
		$exists = $wpdb->get_row("SELECT * FROM $wpdb->post2cat WHERE post_id = $post_ID AND category_id = $post_category");

		if (!$exists && $result) { 
			$wpdb->query("
			INSERT INTO $wpdb->post2cat
			(post_id, category_id)
			VALUES
			($post_ID, $post_category)
			");
		}
	endforeach;
*/
	wp_set_post_cats(1, $post_ID, $post_categories);
	
	if(!$pop3->delete($i)) {
		$logfile .= 'Oops '.$pop3->ERROR."\r\n";
		$pop3->reset();
		wp_cron_send_mail('error', $logfile, $output);
		return;
	} else {
		$logfile .= "Mission complete, message $i deleted.\r\n";
	}

endfor;

wp_cron_send_mail('complete', $logfile, $output);
$pop3->quit();
}

// set a Cron Mail option in the options table of WordPress
function cron_mail_set_option($option_name, $option_value) {
  // first get the existing options in the database
  $mail_options = get_option('cron_mail_options');
  // set the value
  $mail_options[$option_name] = $option_value;
  // write the new options to the database
  update_option('cron_mail_options', $mail_options);
}

// get an option from the WordPress options database table
// if the option does not exist (yet), the default value is returned
function cron_mail_get_option($option_name) {

  // get options from the database
  $mail_options = get_option('cron_mail_options'); 
  
  if (!$mail_options || !array_key_exists($option_name, $mail_options)) {
    // no options in database yet, or not this specific option 
    // create default options array
    $mail_default_options=array();
    $mail_default_options['enable_mail']    = true;
    $mail_default_options['valid_address']  = "";
    $mail_default_options['always_notify']  = 0;
    $mail_default_options['mail_on_manual'] = 0;
    $mail_default_options['min_user_level'] = 0;
    $mail_default_options['publish_post']   = "publish";
	
    // add default options to the database (if options already exist, 
    // add_option does nothing
    add_option('cron_mail_options', $mail_default_options, 
               'Settings for Cron Mail plugin');

    // return default option if option is not in the array in the database
    // this can happen if a new option was added to the array in an upgrade
    // and the options haven't been changed/saved to the database yet
    $result = $mail_default_options[$option_name];

  } else {
    // option found in database
    $result = $mail_options[$option_name];
  }
  
  return $result;
}

// function that is added as an Action to ADMIN_MENU
// it adds an option subpage to the options menu in WordPress administration
function cron_mail_admin() {
  if (function_exists('add_options_page')) {
    add_options_page('Cron Mail Options' /* page title */, 
                     'Cron Mail' /* menu title */, 
                     8 /* min. user level */, 
                     basename(__FILE__) /* php file */ , 
                     'cron_mail_options' /* function for subpanel */);
  }
}

// displays options subpage to set options for Cron Mail and save any
// changes to these options back to the database
function cron_mail_options() {
  if (isset($_POST['info_update'])) {
    ?><div class="updated"><p><strong><?php 
    // process submitted form
    $mail_options = get_option('cron_mail_options');
    $mail_options['valid_address']  = $_POST['valid_address'];
    $mail_options['min_user_level']  = intval($_POST['min_user_level']);
    $mail_options['enable_mail']    = ($_POST['enable_mail'] == "true" ? true : false);
    $mail_options['always_notify']  = ($_POST['always_notify'] == "true" ? true : false);
    $mail_options['mail_on_manual'] = ($_POST['mail_on_manual'] == "true" ? true : false);
    $mail_options['publish_post']   = ($_POST['publish_post'] == "true" ? "publish" : "draft");
    update_option('cron_mail_options', $mail_options);
    
    _e('Options saved', 'cron_mail')
    ?></strong></p></div><?php
	} 
	
	// show options form with current values
	?>
<div class=wrap>
  <form method="post">
    <h2>Cron Mail</h2>
    <fieldset name="general">
      <legend><?php _e('General settings', 'cron_mail') ?></legend>
      <table width="100%" cellspacing="2" cellpadding="5" class="editform">
        <tr>
          <th nowrap valign="top" width="33%"><?php _e('Enable Cron Mail', 'cron_mail') ?></th>
          <td><input type="checkbox" name="enable_mail" id="enable_mail" value="true" <?php if (cron_mail_get_option('enable_mail')) echo "checked"; ?> />
            <br />By unchecking this checkbox the plugin will not check your secret POP3 account for new posts automatically. The functionality of /wp-mail.php will not be affected.
          </td>
        </tr>
        <tr>
          <th nowrap valign="top" width="33%"><?php _e('Always Notify', 'cron_mail') ?></th>
          <td><input type="checkbox" name="always_notify" id="always_notify" value="true" <?php if (cron_mail_get_option('always_notify')) echo "checked"; ?> />
            <br />Enabling this option will cause the plugin to email you every time the POP3 account is checked, whether or not a post was found.
          </td>
        </tr>
        <tr>
          <th nowrap valign="top" width="33%"><?php _e('Publish Method', 'cron_mail') ?></th>
          <td><select name="publish_post" id="publish_post">
            <option value="true" <?php if (cron_mail_get_option('publish_post') == "publish") echo "selected"; ?> >Publish</option>
            <option value="false" <?php if (cron_mail_get_option('publish_post') == "draft") echo "selected"; ?> >Draft</option>
        </select>
            <br />Please select how new posts should be saved.
          </td>
        </tr>
        <tr>
          <th nowrap valign="top" width="33%"><?php _e('Send e-mails on manual checks', 'cron_mail') ?></th>
          <td><input type="checkbox" name="mail_on_manual" id="mail_on_manual" value="true" <?php if (cron_mail_get_option('mail_on_manual')) echo "checked"; ?> />
            <br />Enabling this option will cause the plugin to email you every time the POP3 account is checked via the manual wp-mail.php page.
          </td>
        </tr>
        <tr>
          <th nowrap valign="top" width="33%"><?php _e('User Level', 'cron_mail') ?></th>
          <td><input name="min_user_level" type="text" id="min_user_level" value="<?php echo cron_mail_get_option('min_user_level'); ?>" size="5" />
            Minimum user level allowed to post.<br />
			Enter 0 to disable this check.
          </td>
        </tr>
        <tr>
          <th nowrap valign="top" width="33%"><?php _e('Valid e-mail addresses', 'cron_mail') ?></th>
          <td><input name="valid_address" type="text" id="valid_address" value="<?php echo cron_mail_get_option('valid_address'); ?>" size="50" />
            <br />Registered users can post using their email address. All other emails will be rejected, unless they are listed here. Separate addresses using commas. If you wish to enable all addresses to post to your blog, enter only the character '*' in the text box.
          </td>
        </tr>
      </table>
    </fieldset>
    
    <div class="submit">
      <input type="submit" name="info_update" value="<?php _e('Update options', 'cron_mail') ?>" />
	  </div>
  </form>
</div><?php
}

function wp_cron_send_mail($subject, $body, $output) {
	if ($output) {
		echo preg_replace("/[\r]?[\n]/", "<br />\n", $body);
		echo "<br />";
	}
	if (!$output || cron_mail_get_option('mail_on_manual')) {
		$admin = get_userdata(1);
		mail($admin->user_email, "wp-mail ".$subject, $body);
	}
}

// load texts for localization
load_plugin_textdomain('cron_mail');

// add Cron Mail Options page to the Option menu
add_action('admin_menu', 'cron_mail_admin');

// add actions if enabled
if (cron_mail_get_option('enable_mail')) {
	add_action('wp_cron_15', 'wp_cron_mail');
}

?>